/*
* Classic Space Wars
*
* Copyright 1997, The Plastic Factory, All rights reserved
*
* Author: Peter Hirschberg
*
* Written for Microsoft Visual C++ version 5.0
*
* The released version of the CLASSIC SPACE WARS APPLICATION for Windows 95 is
* available from our website at http://www.advancedaerials.com/plastic/index.htm .
* The current version of this SOURCE CODE is also available here.
*
*
*
* License agreement:
*
* This SOURCE CODE may be distributed in unmodified form to any medium.
*
* The SOURCE CODE or the CLASSIC SPACE WARS APPLICATION may not be sold,
* or sold as a part of a commercial package without the express written
* permission of The Plastic Factory (hippies@mnsinc.com).
* This includes shareware.
*
* *** MODIFIED VERSIONS OF THIS SOURCE CODE OR THE SPACE WARS APPLICATION MAY NOT
* *** BE PUBLICLY REDISTRIBUTED WITHOUT AUTHOR APPROVAL!! (hippies@mnsinc.com).
* This includes distributing via a publicly accessible LAN.
* The Plastic Factory retains all rights to this SOURCE CODE,
* and the CLASSIC SPACE WARS APPLICATION.
*
* The Plastic Factory, and Peter Hirschberg will not be held responsible for
* any damage done by the use of this SOURCE CODE,
* or the CLASSIC SPACE WARS APPLICATION.
* It is purely "as-is".
*
* If you find problems with this SOURCE CODE,
* or make any additions/modifications/improvements,
* PLEASE EMAIL THE PLASTIC FACTORY so that they can be propogated to the
* installed base of CLASSIC SPACE WARS users.
* 
* Thank you!
* 
* Peter Hirschberg
* 
* The Plastic Factory
* Email : hippies@mnsinc.com
* Website : http://www.advancedaerials.com/plastic/index.htm
*
*/


#define STRICT

#include <windows.h>
#include "object.h"
#include "sin_cos.h"


// the first vertex in the ship object's front will always be the 
// starting vertex for the missiles

// *******************************
// player 1 ship
// *******************************

// player 1 ship vertex data...
UINT shipPlayer1NumVerts = 11;
FLOATPOINT shipPlayer1Verts[] = {
	{0,9},
	{-6,-9},
	{-2,-3.5},
	{2,-3.5},
	{6,-9},
	{-1,-6},
	{1,-6},
	{3,0},
	{0,2},
	{-3,0},
	{4,-3}
};


// player 1 ship front line data...
UINT shipPlayer1FrontNumLines = 4;
INTPOINT shipPlayer1FrontLines[] = {
	{0,10},
	{7,8},
	{8,9},
	{9,0},
};

// player 1 ship right line data...
UINT shipPlayer1RightNumLines = 4;
INTPOINT shipPlayer1RightLines[] = {
	{9,1},
	{1,2},
	{2,5},
	{2,3}
};

// player 1 ship left line data...
UINT shipPlayer1LeftNumLines = 4;
INTPOINT shipPlayer1LeftLines[] = {
	{5,6},
	{6,3},
	{3,4},
	{4,10}
};


// *******************************
// player 2 ship
// *******************************

// player 2 ship vertex data...
UINT shipPlayer2NumVerts = 19;
FLOATPOINT shipPlayer2Verts[] = {
    {0.0,5.5},
    {-3.0,4.0},
    {-3.0,0.5},
    {0.0,-1.5},
    {3.0,0.5},
    {3.0,4.0},

    {-1.5,-1.0},
    {0.0,-6.0},
    {1.5,-1.0},
    {-3.5,-2.0},
    {-3.5,-11.0},

    {3.5,-2.0},
    {3.5,-11.0},

    {-3.5,-6.5},
    {-0.5,-4.5},

    {0.5,-4.5},
    {3.5,-6.5},

    {0.0,4.5},
    {0.0,3.0},
};

// player 2 ship front line data...
UINT shipPlayer2FrontNumLines = 5;
INTPOINT shipPlayer2FrontLines[] = {
	{0,1},
	{1,2},
	{0,5},
	{5,4},
	{17,18}
};

// player 2 ship right line data...
UINT shipPlayer2RightNumLines = 4;
INTPOINT shipPlayer2RightLines[] = {
	{2,3},
	{6,7},
	{9,10},
	{13,14}
};

// player 2 ship left line data...
UINT shipPlayer2LeftNumLines = 4;
INTPOINT shipPlayer2LeftLines[] = {
	{3,4},
	{7,8},
	{11,12},
	{15,16}
};

// *******************************
// asteroid
// *******************************

// asteroid vertex data...
UINT asteroidNumVerts = 8;
FLOATPOINT asteroidVerts[] = {
	{-2.5,1},
	{-5,2.5},
	{-5,-1},
	{-3,-3.5},
	{3,-3},
	{5,1},
	{1,4},
	{-2,3.5}
};

// asteroid line data...
UINT asteroidNumLines = 8;
INTPOINT asteroidLines[] = {
	{0,1},
	{1,2},
	{2,3},
	{3,4},
	{4,5},
	{5,6},
	{6,7},
	{7,0}
};

// *******************************
// player 1 ship thrust flame
// *******************************

// player 1 ship "thrust flame" vertex data...
UINT flamePlayer1NumVerts = 4;
FLOATPOINT flamePlayer1Verts[] = {
	{0,-6},
	{0.5,-6.5},
	{0,-8.5},
	{-0.5,-6.5}
};

// player 1 ship "thrust flame" line data...
UINT flamePlayer1NumLines = 4;
INTPOINT flamePlayer1Lines[] = {
	{0,1},
	{1,2},
	{2,3},
	{3,0}
};

// *******************************
// player 1 ship thrust flame
// *******************************

// player 2 ship "thrust flame" vertex data...
UINT flamePlayer2NumVerts = 4;
FLOATPOINT flamePlayer2Verts[] = {
	{0,-6},
	{0.5,-6.5},
	{0,-8.5},
	{-0.5,-6.5}
};

// player 2 ship "thrust flame" line data...
UINT flamePlayer2NumLines = 4;
INTPOINT flamePlayer2Lines[] = {
	{0,1},
	{1,2},
	{2,3},
	{3,0}
};

// *******************************
// sun
// *******************************

// sun vertex data...
UINT sunNumVerts = 16;
FLOATPOINT sunVerts[] = {
 	{0,1},
 	{0,-1},
 	{1,0},
 	{-1,0},

 	{1,1},
 	{-1,-1},
 	{1,-1},
 	{-1,1},

 	{5,0},
 	{0,5},
  	{-5,0},
  	{0,-5},

  	{4,4},
  	{-4,-4},
  	{-4,4},
  	{4,-4},
};

// sun line data...
UINT sunANumLines = 4;
INTPOINT sunALines[] = {
	{2,8},
	{0,9},
	{3,10},
	{1,11}
};
UINT sunBNumLines = 4;
INTPOINT sunBLines[] = {
	{4,12},
	{5,13},
	{7,14},
	{6,15}
};


// *******************************
// missile
// *******************************

// missile vertex data...
UINT missileNumVerts = 2;
FLOATPOINT missileVerts[] = {
	{0,0},
	{0,1}
};

// missile line data...
UINT missileNumLines = 1;
INTPOINT missileLines[] = {
	{0,1}
};


// *******************************
// "game over"
// *******************************

// gameover vertex data...
UINT gameoverNumVerts = 44;
FLOATPOINT gameoverVerts[] = {
	{-23,-3},	// G
	{-26,-3},
	{-26,3},
	{-23,3},
	{-23,0},
	{-24.5,0},
	{-20,3},	// A
	{-20,0},
	{-20,-3},
	{-17,-3},
	{-17,0},
	{-17,3},
	{-14,3},	// M
	{-14,-3},
	{-12.5,0},
	{-11,-3},
	{-11,3},
	{-5,3},		// E
	{-8,3},
	{-8,0},
	{-6,0},
	{-8,-3},
	{-5,-3},
	{5,3},		// O
	{5,-3},
	{8,-3},
	{8,3},
	{11,-3},	// V
	{11,0},
	{12.5,3},
	{14,0},
	{14,-3},
	{20,3},		// E
	{17,3},
	{17,0},
	{19,0},
	{17,-3},
	{20,-3},
	{23,3},		// R
	{23,0},
	{23,-3},
	{26,-3},
	{26,0},
	{26,3}
};


// gameover line data...
UINT gameoverNumLines = 34;
INTPOINT gameoverLines[] = {
	{0,1},		// G
	{1,2},
	{2,3},
	{3,4},
	{4,5},
	{6,8},		// A
	{8,9},
	{9,11},
	{7,10},
	{12,13},	// M
	{13,14},
	{14,15},
	{15,16},
	{17,18},	// E
	{18,21},
	{21,22},
	{19,20},
	{23,24},	// O
	{24,25},
	{25,26},
	{26,23},
	{27,28},	// V
	{28,29},
	{29,30},
	{30,31},
	{32,33},	// E
	{33,36},
	{36,37},
	{34,35},
	{38,40},	// R
	{40,41},
	{41,42},
	{42,39},
	{39,43}
};


// object scales
float shipPlayer1Scale	= 0.9;
float shipPlayer2Scale	= 1.0;
float asteroidScale		= 1.0;
float flamePlayer1Scale = 0.9;
float flamePlayer2Scale = 1.0;
float missileScale		= 1.5;
float sunScale			= 1.0;
float gameoverScale		= 2.0;



// instanciate the objects
Object2d	shipPlayer1Front;
Object2d	shipPlayer1Right;
Object2d	shipPlayer1Left;
Object2d	shipPlayer2Front;
Object2d	shipPlayer2Right;
Object2d	shipPlayer2Left;
Object2d	asteroid;
Object2d	flamePlayer1;
Object2d	flamePlayer2;
Object2d	sunA;
Object2d	sunB;
Object2d	player1Missiles[MAX_MISSILES];
Object2d	player2Missiles[MAX_MISSILES];
Object2d	debris[MAX_DEBRIS];
Object2d	gameoverObj;

shipObject2d	shipPlayer1;
shipObject2d	shipPlayer2;


/***********************************************************************
*         *** Object2d::DrawObject() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
void Object2d::DrawObject(HDC DC){
float	x,y;
HPEN	hPen, hPenOld;
unsigned int i;
float xfrom1, yfrom1, xto1, yto1;
float xfrom2, yfrom2, xto2, yto2;
float scaler;
int bright;
	

	// init extents
	m_invRectOld = m_invRect;
	m_invRect = MakeAreaRect(32000,32000,-32000,-32000);

	// calculate scaling...
	if (ScreenXScaler < ScreenYScaler){
		scaler = ScreenXScaler;
	} else {
		scaler = ScreenYScaler;
	}

	// scale the desired position to the screen
	x = m_pos.x * ScreenXScaler;
	y = m_pos.y * ScreenYScaler;

	// set brightness
	if (m_flashtimer){
		bright = m_flashbright;
	} else {
		bright = m_brightness;
	}

	// select a pen...
	hPen = CreatePen(PS_SOLID, 0, RGB(bright, bright, bright));
	hPenOld = (HPEN)SelectObject(DC, hPen);

	// rotate, position and draw the object...
	for (i=0; i < (m_numLines); i++){
		xfrom1 = (m_verts[ (m_lines[i].x) ].x) * m_scale;
		yfrom1 = (m_verts[ (m_lines[i].x) ].y) * m_scale;
		xto1 = (m_verts[ (m_lines[i].y) ].x) * m_scale;
		yto1 = (m_verts[ (m_lines[i].y) ].y) * m_scale;

		// rotate the verticies...
		xfrom2 =(xfrom1*COS(m_rotation))-(yfrom1*SIN(m_rotation));
		yfrom2 =(yfrom1*COS(m_rotation))+(xfrom1*SIN(m_rotation));
		xto2 =(xto1*COS(m_rotation))-(yto1*SIN(m_rotation));
		yto2 =(yto1*COS(m_rotation))+(xto1*SIN(m_rotation));

		// scale the object to the screen
		xfrom2 *= scaler;
		yfrom2 *= scaler;
		xto2 *= scaler;
		yto2 *= scaler;

		// draw...
		MoveToEx(DC, (xfrom2+x), (yfrom2+y), NULL);
		LineTo(DC, (xto2+x), (yto2+y));
		// because Windows LineTo() doesn't draw the last pixel
		LineTo(DC, (xto2+x)+1, (yto2+y)+1);

		// update extents...
		if ((xfrom2+x) < m_invRect.left){ m_invRect.left = (xfrom2+x); }
		if ((xfrom2+x) > m_invRect.right){ m_invRect.right = (xfrom2+x); }
		if ((yfrom2+y) < m_invRect.top){ m_invRect.top = (yfrom2+y); }
		if ((yfrom2+y) > m_invRect.bottom){ m_invRect.bottom = (yfrom2+y); }
		if ((xto2+x) < m_invRect.left){ m_invRect.left = (xto2+x); }
		if ((xto2+x) > m_invRect.right){ m_invRect.right = (xto2+x); }
		if ((yto2+y) < m_invRect.top){ m_invRect.top = (yto2+y); }
		if ((yto2+y) > m_invRect.bottom){ m_invRect.bottom = (yto2+y); }

	}

	if (m_prevNotVis){
		m_prevNotVis = FALSE;
		m_invRectOld = m_invRect;
	}

	// remove pen...
	SelectObject(DC, hPenOld);
	DeleteObject(hPen);
}







// helper functions

/***********************************************************************
*         *** AreaRectUnion() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
AREARECT AreaRectUnion(AREARECT rect1, AREARECT rect2){
AREARECT rectResult;

	rectResult.left = (rect1.left < rect2.left) ? (rect1.left) : (rect2.left);
	rectResult.top = (rect1.top < rect2.top) ? (rect1.top) : (rect2.top);
	rectResult.right = (rect1.right > rect2.right) ? (rect1.right) : (rect2.right);
	rectResult.bottom = (rect1.bottom > rect2.bottom) ? (rect1.bottom) : (rect2.bottom);

	return rectResult;
}


/***********************************************************************
*         *** DoRectsIntersect() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
BOOL DoRectsIntersect(AREARECT rect1, AREARECT rect2){

	if (((rect1.left >= rect2.left) && (rect1.left <= rect2.right)
		|| (rect1.right >= rect2.left) && (rect1.right <= rect2.right))
		&& ((rect1.top >= rect2.top) && (rect1.top <= rect2.bottom)
		|| (rect1.bottom >= rect2.top) && (rect1.bottom <= rect2.bottom))){
		return TRUE;
	}

	return FALSE;
}


/***********************************************************************
*         *** RotatePoint() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
FLOATPOINT RotatePoint(FLOATPOINT oldPoint, int angle){
FLOATPOINT	newPoint;

	newPoint.x =(oldPoint.x*COS(angle))-(oldPoint.y*SIN(angle));
	newPoint.y =(oldPoint.y*COS(angle))+(oldPoint.x*SIN(angle));

	return newPoint;
}


/***********************************************************************
*         *** MakeIntPoint ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
INTPOINT MakeIntPoint(int x, int y){
INTPOINT point;
	point.x = x;
	point.y = y;
	return point;	
}


/***********************************************************************
*         *** MakeFloatPoint() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
FLOATPOINT MakeFloatPoint(float x, float y){
FLOATPOINT point;
	point.x = x;
	point.y = y;
	return point;	
}


/***********************************************************************
*         *** MakeAreaRect() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
AREARECT MakeAreaRect(int left, int top, int right, int bottom){
AREARECT	rect;
	rect.left = left;
	rect.top = top;
	rect.right = right;
	rect.bottom = bottom;
	return rect;	
}


/***********************************************************************
*         *** LineRectIntersect() ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
BOOL LineRectIntersect(FLOATPOINT fromPt, FLOATPOINT toPt, AREARECT rect){
int y_unit,x_unit;
float x1, y1, x2, y2, xPos, yPos;

	// init coordinates
	x1 = fromPt.x;
	y1 = fromPt.y;
	x2 = toPt.x;
	y2 = toPt.y;
	xPos = x1;
	yPos = y1;

	// Calculate difference between  y coordinates
	int ydiff=y2-y1;		

	// If the line moves in the negative direction
	if (ydiff<0) {			
		// get absolute value of difference and set negative unit in y dimension
		ydiff=-ydiff;		
		y_unit=-1;
							
	} else {
		// Else set positive unit in y dimension
		y_unit=1;		
	}

	// Calculate difference between x coordinates
	int xdiff=x2-x1;		

	// If the line moves in the negative direction
	if (xdiff<0) {			
		// get absolute value of difference and set negative unit in x dimension
		xdiff=-xdiff;		
		x_unit=-1;			
	} else {
		// Else set positive unit in y dimension
		x_unit=1;			
	}

	// Initialize error term
	int error_term=0;		
	
	if (xdiff>ydiff) {		
		// If difference is bigger in x dimension, prepare to count off in x direction
		int length=xdiff+1;		

		// Loop through points in x direction
		for (int i=0; i<length; i++) {

			// check this pixel for intersection...
			if (((xPos >= (rect.left)) && (xPos <= (rect.right)))
				&& ((yPos >= (rect.top)) && (yPos <= (rect.bottom)))){
				// point is within the rectangle
				return TRUE;
			}

			// Move offset to next pixel in x direction
			xPos+=x_unit;			

			// Check to see if move required in y direction
			error_term+=ydiff;		
			if (error_term>xdiff) {	
				// reset error term and move offset to next pixel in y dir
				error_term-=xdiff;
				yPos+=y_unit;
			}
		}
	} else {
		// If difference is bigger in y dimension, prepare to count off in y direction
		int length=ydiff+1;

		// Loop through points in y direction
		for (int i=0; i<length; i++) {

			// check this pixel for intersection...
			if (((xPos >= (rect.left)) && (xPos <= (rect.right)))
				&& ((yPos >= (rect.top)) && (yPos <= (rect.bottom)))){
				// point is within the rectangle
				return TRUE;
			}

			// Move offset to next pixel in y direction
			yPos+=y_unit;			

			// Check to see if move required in x direction
			error_term+=xdiff;		
			if (error_term>0) {		
				// reset error term and move offset to next pixel in x dir
				error_term-=ydiff;
				xPos+=x_unit;
			}
		}
	}


	return FALSE;
}
