/*
* Classic Space Wars
*
* Copyright 1997, The Plastic Factory, All rights reserved
*
* Author: Peter Hirschberg
*
* Written for Microsoft Visual C++ version 5.0
*
* The released version of the CLASSIC SPACE WARS APPLICATION for Windows 95 is
* available from our website at http://www.advancedaerials.com/plastic/index.htm .
* The current version of this SOURCE CODE is also available here.
*
*
*
* License agreement:
*
* This SOURCE CODE may be distributed in unmodified form to any medium.
*
* The SOURCE CODE or the CLASSIC SPACE WARS APPLICATION may not be sold,
* or sold as a part of a commercial package without the express written
* permission of The Plastic Factory (hippies@mnsinc.com).
* This includes shareware.
*
* *** MODIFIED VERSIONS OF THIS SOURCE CODE OR THE SPACE WARS APPLICATION MAY NOT
* *** BE PUBLICLY REDISTRIBUTED WITHOUT AUTHOR APPROVAL!! (hippies@mnsinc.com).
* This includes distributing via a publicly accessible LAN.
* The Plastic Factory retains all rights to this SOURCE CODE,
* and the CLASSIC SPACE WARS APPLICATION.
*
* The Plastic Factory, and Peter Hirschberg will not be held responsible for
* any damage done by the use of this SOURCE CODE,
* or the CLASSIC SPACE WARS APPLICATION.
* It is purely "as-is".
*
* If you find problems with this SOURCE CODE,
* or make any additions/modifications/improvements,
* PLEASE EMAIL THE PLASTIC FACTORY so that they can be propogated to the
* installed base of CLASSIC SPACE WARS users.
* 
* Thank you!
* 
* Peter Hirschberg
* 
* The Plastic Factory
* Email : hippies@mnsinc.com
* Website : http://www.advancedaerials.com/plastic/index.htm
*
*/
 

#define STRICT

#include <windows.h>
#include "digits.h"
#include "object.h"


// externs
extern unsigned	int		NormBright;
extern float			fragTimer;
extern float			attractTimer;
extern BOOL				gameOver;
extern UINT				player1Frags;
extern UINT				player2Frags;
extern float			player1Fuel;
extern float			player2Fuel;
extern UINT				player1NumMissiles;
extern UINT				player2NumMissiles;
extern int				roundTime;


// defines
#define DIGITBRIGHTNESS				NormBright
#define	DIGIT_WIDTH					3
#define DIGIT_HEIGHT				4
#define DIGIT_HSPACING				((DIGIT_WIDTH*.45) + DIGIT_WIDTH)
#define DIGIT_VSPACING				10


#define ROUNDTIME_XPOS			310
#define ROUNDTIME_YPOS			80
#define ROUNDTIME_SCALE			(1.5)
#define PLAYER1FUEL_XPOS		150
#define PLAYER1FUEL_YPOS		80
#define PLAYER1FUEL_SCALE		(1.5)
#define PLAYER2FUEL_XPOS		450
#define PLAYER2FUEL_YPOS		80
#define PLAYER2FUEL_SCALE		(1.5)
#define PLAYER1MISSILES_XPOS	156
#define PLAYER1MISSILES_YPOS	90
#define PLAYER1MISSILES_SCALE	(1.5)
#define PLAYER2MISSILES_XPOS	456
#define PLAYER2MISSILES_YPOS	90
#define PLAYER2MISSILES_SCALE	(1.5)
#define PLAYER1FRAGS_XPOS		100
#define PLAYER1FRAGS_YPOS		100
#define PLAYER1FRAGS_SCALE		8
#define PLAYER2FRAGS_XPOS		475
#define PLAYER2FRAGS_YPOS		100
#define PLAYER2FRAGS_SCALE		8


unsigned int	digitBrightness = DIGITBRIGHTNESS;
float			digitHeight = DIGIT_HEIGHT;
float			digitWidth = DIGIT_WIDTH;
float			digitHSpacing = DIGIT_HSPACING;
int				roundtimeXPos = ROUNDTIME_XPOS;
int				roundtimeYPos = ROUNDTIME_YPOS;
float			roundtimeScale = ROUNDTIME_SCALE;
int				player1FuelXPos = PLAYER1FUEL_XPOS;
int				player1FuelYPos = PLAYER1FUEL_YPOS;
float			player1FuelScale = PLAYER1FUEL_SCALE;
int				player2FuelXPos = PLAYER2FUEL_XPOS;
int				player2FuelYPos = PLAYER2FUEL_YPOS;
float			player2FuelScale = PLAYER2FUEL_SCALE;
int				player1MissilesXPos = PLAYER1MISSILES_XPOS;
int				player1MissilesYPos = PLAYER1MISSILES_YPOS;
float			player1MissilesScale = PLAYER1MISSILES_SCALE;
int				player2MissilesXPos = PLAYER2MISSILES_XPOS;
int				player2MissilesYPos = PLAYER2MISSILES_YPOS;
float			player2MissilesScale = PLAYER2MISSILES_SCALE;
int				player1FragsXPos = PLAYER1FRAGS_XPOS;
int				player1FragsYPos = PLAYER1FRAGS_YPOS;
float			player1FragsScale = PLAYER1FRAGS_SCALE;
int				player2FragsXPos = PLAYER2FRAGS_XPOS;
int				player2FragsYPos = PLAYER2FRAGS_YPOS;
float			player2FragsScale = PLAYER2FRAGS_SCALE;



/* digit segment coordinates

--0--
|   |
1   5
|-6-|
2   4
|   |
--3--

*/
#define DIGSEG_0	0x01
#define DIGSEG_1	0x02
#define DIGSEG_2	0x04
#define DIGSEG_3	0x08
#define DIGSEG_4	0x10
#define DIGSEG_5	0x20
#define DIGSEG_6	0x40
UCHAR	digitSegDefine[] = {
	{ DIGSEG_0 | DIGSEG_1 | DIGSEG_2 | DIGSEG_3 | DIGSEG_4 | DIGSEG_5}, /* 0 */
	{ DIGSEG_4 | DIGSEG_5}, /* 1 */
	{ DIGSEG_0 | DIGSEG_5 | DIGSEG_6 | DIGSEG_2 | DIGSEG_3}, /* 2 */
	{ DIGSEG_0 | DIGSEG_5 | DIGSEG_4 | DIGSEG_3 | DIGSEG_6}, /* 3 */
	{ DIGSEG_1 | DIGSEG_6 | DIGSEG_5 | DIGSEG_4}, /* 4 */
	{ DIGSEG_0 | DIGSEG_1 | DIGSEG_6 | DIGSEG_4 | DIGSEG_3}, /* 5 */
	{ DIGSEG_0 | DIGSEG_1 | DIGSEG_2 | DIGSEG_3 | DIGSEG_4 | DIGSEG_6}, /* 6 */
	{ DIGSEG_0 | DIGSEG_5 | DIGSEG_4}, /* 7 */
	{ DIGSEG_0 | DIGSEG_1 | DIGSEG_2 | DIGSEG_3 | DIGSEG_4 | DIGSEG_5 | DIGSEG_6}, /* 8 */
	{ DIGSEG_6 | DIGSEG_1 | DIGSEG_0 | DIGSEG_5 | DIGSEG_4 | DIGSEG_3} /* 9 */
};
FLOATLINE digitSegCoord[] = {
	{1.25,-2,-1.25,-2},
	{-1.25,-2,-1.25,0},
	{-1.25,0,-1.25,2},
	{-1.25,2,1.25,2},
	{1.25,2,1.25,0},
	{1.25,0,1.25,-2},
	{1.25,0,-1.25,0}
};
UCHAR digitSegList[] = {
	DIGSEG_0,
	DIGSEG_1,
	DIGSEG_2,
	DIGSEG_3,
	DIGSEG_4,
	DIGSEG_5,
	DIGSEG_6,
	0x00
};


void DrawDigit(HDC DC, UINT digit, FLOATPOINT pos, float scale, int brightness);



void DrawDigit(HDC DC, UINT digit, FLOATPOINT pos, float scale, int brightness){
UINT	segFlags;
HPEN	hPen, hPenOld;
FLOATLINE	line;
int		i;


	if (digit > 9) { return; }
	segFlags = digitSegDefine[digit];
	
   // select a pen...
	hPen = CreatePen(PS_SOLID, 0, RGB(brightness, brightness, brightness));
	hPenOld = (HPEN)SelectObject(DC, hPen);

	// draw...
	for (i=0; digitSegList[i] != 0; i++){
		if (segFlags & digitSegList[i]){
			line = digitSegCoord[i];
			MoveToEx(DC, ((line.from.x*scale*ScreenXScaler)+(pos.x*ScreenXScaler)), ((line.from.y*scale*ScreenYScaler)+(pos.y*ScreenYScaler)), NULL);
			LineTo(DC, ((line.to.x*scale*ScreenXScaler)+(pos.x*ScreenXScaler)), ((line.to.y*scale*ScreenYScaler)+(pos.y*ScreenYScaler)));
			// because Windows LineTo() doesn't draw the last pixel
			LineTo(DC, ((line.to.x*scale*ScreenXScaler)+(pos.x*ScreenXScaler))+1, ((line.to.y*scale*ScreenYScaler)+(pos.y*ScreenYScaler))+1);
		}
	}
	
	// remove pen...
	SelectObject(DC, hPenOld);
	DeleteObject(hPen);

}



void DrawScore(HDC DC, int brightness){
int digit;
FLOATPOINT pos;

	if (gameOver && !attractTimer){
		// no display in attract mode
		return;
	}

	// round time
	if (roundTime >= 60){
		digit = (UINT)roundTime / 60;	
	} else {
		digit = 0;
	}
	pos = MakeFloatPoint(roundtimeXPos, roundtimeYPos);
	DrawDigit(DC, digit, pos, roundtimeScale, brightness);

	digit = (UINT)(roundTime % 60) / 10;
	pos.x += (digitWidth + digitHSpacing) * roundtimeScale;
	DrawDigit(DC, digit, pos, roundtimeScale, brightness);

	digit = (UINT)(roundTime % 60) % 10;
	pos.x += digitHSpacing * roundtimeScale;
	DrawDigit(DC, digit, pos, roundtimeScale, brightness);


	if (gameOver || fragTimer){

		// player1 frags
		pos = MakeFloatPoint(player1FragsXPos, player1FragsYPos);
		digit = (UINT)(player1Frags / 10);
		if (digit){
			DrawDigit(DC, digit, pos, player1FragsScale, brightness);
		}
		pos.x += digitHSpacing * player1FragsScale;
		digit = (UINT)(player1Frags % 10);
		DrawDigit(DC, digit, pos, player1FragsScale, brightness);
	
		// player2 frags
		pos = MakeFloatPoint(player2FragsXPos, player2FragsYPos);
		digit = (UINT)(player2Frags / 10);
		if (digit){
			DrawDigit(DC, digit, pos, player2FragsScale, brightness);
		}
		pos.x += digitHSpacing * player2FragsScale;
		digit = (UINT)(player2Frags % 10);
		DrawDigit(DC, digit, pos, player2FragsScale, brightness);

	} else {

		// player1 fuel
		pos = MakeFloatPoint(player1FuelXPos, player1FuelYPos);
		digit = (UINT)(player1Fuel / 100);
		if (digit){
			DrawDigit(DC, digit, pos, player1FuelScale, brightness);
		}

		pos.x += digitHSpacing * player1FuelScale;
		digit = (UINT)(((UINT)player1Fuel / 10) % 10);
		if (digit || (player1Fuel >= 100)){
			DrawDigit(DC, digit, pos, player1FuelScale, brightness);
		}

		pos.x += digitHSpacing * player1FuelScale;
		digit = (UINT)((UINT)player1Fuel % 10);
		DrawDigit(DC, digit, pos, player1FuelScale, brightness);

		// player2 fuel
		pos = MakeFloatPoint(player2FuelXPos, player2FuelYPos);
		digit = (UINT)(player2Fuel / 100);
		if (digit){
			DrawDigit(DC, digit, pos, player2FuelScale, brightness);
		}

		pos.x += digitHSpacing * player2FuelScale;
		digit = (UINT)(((UINT)player2Fuel / 10) % 10);
		if (digit || (player2Fuel >= 100)){
			DrawDigit(DC, digit, pos, player2FuelScale, brightness);
		}

		pos.x += digitHSpacing * player2FuelScale;
		digit = (UINT)((UINT)player2Fuel % 10);
		DrawDigit(DC, digit, pos, player2FuelScale, brightness);

		// player1 missiles
		pos = MakeFloatPoint(player1MissilesXPos, player1MissilesYPos);
		digit = (UINT)(player1NumMissiles / 10);
		if (digit){
			DrawDigit(DC, digit, pos, player1MissilesScale, brightness);
		}

		pos.x += digitHSpacing * player1MissilesScale;
		digit = (UINT)(player1NumMissiles % 10);
		DrawDigit(DC, digit, pos, player1MissilesScale, brightness);

		// player2 missiles
		pos = MakeFloatPoint(player2MissilesXPos, player2MissilesYPos);
		digit = (UINT)(player2NumMissiles / 10);
		if (digit){
			DrawDigit(DC, digit, pos, player2MissilesScale, brightness);
		}

		pos.x += digitHSpacing * player2MissilesScale;
		digit = (UINT)(player2NumMissiles % 10);
		DrawDigit(DC, digit, pos, player2MissilesScale, brightness);

	}

}


void BltScore(HDC dstDC, HDC srcDC){

	// round time
	BitBlt
		(dstDC,
		(roundtimeXPos-((digitWidth*roundtimeScale)/(float)2)) * ScreenXScaler,
		(roundtimeYPos-(((float)digitHeight*roundtimeScale)/(float)2)) * ScreenYScaler,
		(((digitWidth + (digitHSpacing*(float)3)) * roundtimeScale) * ScreenXScaler) + 1,
		((digitHeight * roundtimeScale) * ScreenYScaler) + 2,
		srcDC,
		(roundtimeXPos-((digitWidth*roundtimeScale)/(float)2)) * ScreenXScaler,
		(roundtimeYPos-(((float)digitHeight*roundtimeScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

	// player1 frags
	BitBlt
		(dstDC,
		(player1FragsXPos-((digitWidth*player1FragsScale)/(float)2)) * ScreenXScaler,
		(player1FragsYPos-(((float)digitHeight*player1FragsScale)/(float)2)) * ScreenYScaler,
		(((digitWidth + (digitHSpacing*(float)3)) * player1FragsScale) * ScreenXScaler) + 1,
		((digitHeight * player1FragsScale) * ScreenYScaler) + 2,
		srcDC,
		(player1FragsXPos-((digitWidth*player1FragsScale)/(float)2)) * ScreenXScaler,
		(player1FragsYPos-(((float)digitHeight*player1FragsScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

	// player2 score
	BitBlt
		(dstDC,
		(player2FragsXPos-((digitWidth*player2FragsScale)/(float)2)) * ScreenXScaler,
		(player2FragsYPos-(((float)digitHeight*player2FragsScale)/(float)2)) * ScreenYScaler,
		(((digitWidth + (digitHSpacing*(float)3)) * player2FragsScale) * ScreenXScaler) + 1,
		((digitHeight * player2FragsScale) * ScreenYScaler) + 2,
		srcDC,
		(player2FragsXPos-((digitWidth*player2FragsScale)/(float)2)) * ScreenXScaler,
		(player2FragsYPos-(((float)digitHeight*player2FragsScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

	// player1 fuel
	BitBlt
		(dstDC,
		(player1FuelXPos-((digitWidth*player1FuelScale)/(float)2)) * ScreenXScaler,
		(player1FuelYPos-(((float)digitHeight*player1FuelScale)/(float)2)) * ScreenYScaler,
		(((digitHSpacing*(float)3) * player1FuelScale) * ScreenXScaler) + 1,
		((digitHeight * player1FuelScale) * ScreenYScaler) + 2,
		srcDC,
		(player1FuelXPos-((digitWidth*player1FuelScale)/(float)2)) * ScreenXScaler,
		(player1FuelYPos-(((float)digitHeight*player1FuelScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

	// player2 fuel
	BitBlt
		(dstDC,
		(player2FuelXPos-((digitWidth*player2FuelScale)/(float)2)) * ScreenXScaler,
		(player2FuelYPos-(((float)digitHeight*player2FuelScale)/(float)2)) * ScreenYScaler,
		(((digitHSpacing*(float)3) * player2FuelScale) * ScreenXScaler) + 1,
		((digitHeight * player2FuelScale) * ScreenYScaler) + 2,
		srcDC,
		(player2FuelXPos-((digitWidth*player2FuelScale)/(float)2)) * ScreenXScaler,
		(player2FuelYPos-(((float)digitHeight*player2FuelScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

	// player1 missiles
	BitBlt
		(dstDC,
		(player1MissilesXPos-((digitWidth*player1MissilesScale)/(float)2)) * ScreenXScaler,
		(player1MissilesYPos-(((float)digitHeight*player1MissilesScale)/(float)2)) * ScreenYScaler,
		(((digitWidth + (digitHSpacing*(float)3)) * player1MissilesScale) * ScreenXScaler) + 1,
		((digitHeight * player1MissilesScale) * ScreenYScaler) + 2,
		srcDC,
		(player1MissilesXPos-((digitWidth*player1MissilesScale)/(float)2)) * ScreenXScaler,
		(player1MissilesYPos-(((float)digitHeight*player1MissilesScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

	// player2 missiles
	BitBlt
		(dstDC,
		(player2MissilesXPos-((digitWidth*player2MissilesScale)/(float)2)) * ScreenXScaler,
		(player2MissilesYPos-(((float)digitHeight*player2MissilesScale)/(float)2)) * ScreenYScaler,
		(((digitWidth + (digitHSpacing*(float)3)) * player2MissilesScale) * ScreenXScaler) + 1,
		((digitHeight * player2MissilesScale) * ScreenYScaler) + 2,
		srcDC,
		(player2MissilesXPos-((digitWidth*player2MissilesScale)/(float)2)) * ScreenXScaler,
		(player2MissilesYPos-(((float)digitHeight*player2MissilesScale)/(float)2)) * ScreenYScaler,
		SRCCOPY);

}
